package require Dayswig_tcl
package provide libdaytcl 1.0

#
# provide a list of all element symbols defined
# by the daylight toolkits
#

proc du_list_elements {} {
    # initialize list of symbols
    set symbols {};
    # create a molecule
    set mol [dt_alloc_mol];
    # allow it to be modified
    dt_mod_on $mol;
    # add a hydrogen atom
    set a [dt_addatom $mol 1 0];
    # loop until an internal condition is met
    while {1} {
	# find the current symbol of the atom
	set symbol [dt_symbol $a];
	# test for termination
	if {"$symbol" == {}} {
	    # if there is no symbol, then we're done
	    break;
	} else {
	    # otherwise save the symbol
	    lappend symbols $symbol;
	    # and increment the atomic number of our atom
	    dt_setnumber $a [expr 1+[dt_number $a]];
	}
    }
    # get rid of our molecule
    dt_mod_off $mol;
    dt_dealloc $mol;
    # return the list of symbols
    return $symbols;
}